using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
	/// 数据访问类:T_Bus_ToExamine
	/// </summary>
	public partial class T_Bus_ToExamine
    {
        public T_Bus_ToExamine()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_ID", "T_Bus_ToExamine");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Bus_ToExamine");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Bus_ToExamine model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Bus_ToExamine(");
            strSql.Append("F_WorkOrderId,F_AssignedId,F_CreatUser,F_Type,F_Result,F_IsDelete,AuditUser,F_State,F_MainDeptId,F_LimitTime,F_Content)");
            strSql.Append(" values (");
            strSql.Append("@F_WorkOrderId,@F_AssignedId,@F_CreatUser,@F_Type,@F_Result,@F_IsDelete,@AuditUser,@F_State,@F_MainDeptId,@F_LimitTime,@F_Content)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_AssignedId", SqlDbType.Int,4),
                    new SqlParameter("@F_CreatUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_Result", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@AuditUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_MainDeptId", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_State", SqlDbType.Int,4) ,
             new SqlParameter("@F_LimitTime", SqlDbType.Int,4),
             new SqlParameter("@F_Content", SqlDbType.NVarChar,-1)};
            parameters[0].Value = model.F_WorkOrderId;
            parameters[1].Value = model.F_AssignedId;
            parameters[2].Value = model.F_CreatUser;
            parameters[3].Value = model.F_Type;
            parameters[4].Value = model.F_Result;
            parameters[5].Value = model.F_IsDelete;
            parameters[6].Value = model.AuditUser;
            parameters[7].Value = model.F_MainDeptId;
            parameters[8].Value = model.F_State;
            parameters[9].Value = model.F_LimitTime;
            parameters[10].Value = model.F_Content;
            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Bus_ToExamine model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Bus_ToExamine set ");
            strSql.Append("F_WorkOrderId=@F_WorkOrderId,");
            strSql.Append("F_AssignedId=@F_AssignedId,");
            strSql.Append("F_CreatUser=@F_CreatUser,");
            strSql.Append("F_Type=@F_Type,");
            strSql.Append("F_Result=@F_Result,");
            strSql.Append("AuditUser=@AuditUser,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_MainDeptId=@F_MainDeptId,");
            strSql.Append("F_LimitTime=@F_LimitTime,");
            strSql.Append("F_Content=@F_Content,");
            strSql.Append("F_IsDelete=@F_IsDelete");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_AssignedId", SqlDbType.Int,4),
                    new SqlParameter("@F_CreatUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_Result", SqlDbType.NVarChar,-1),
                        new SqlParameter("@AuditUser", SqlDbType.NVarChar,50),
                         new SqlParameter("@F_State", SqlDbType.Int,4),
                          new SqlParameter("@F_MainDeptId", SqlDbType.NVarChar,500),
                           new SqlParameter("@F_LimitTime", SqlDbType.Int,4),
                            new SqlParameter("@F_Content", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.F_WorkOrderId;
            parameters[1].Value = model.F_AssignedId;
            parameters[2].Value = model.F_CreatUser;
            parameters[3].Value = model.F_Type;
            parameters[4].Value = model.F_Result;
            parameters[5].Value = model.AuditUser;
            parameters[6].Value = model.F_State;
            parameters[7].Value = model.F_MainDeptId;
            parameters[8].Value = model.F_LimitTime;
            parameters[9].Value = model.F_Content;
            parameters[10].Value = model.F_IsDelete;
            parameters[11].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Bus_ToExamine ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Bus_ToExamine ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_ToExamine GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,F_WorkOrderId,F_AssignedId,F_CreatUser,F_Type,F_Result,F_IsDelete,AuditUser,F_State,F_LimitTime,F_MainDeptId,F_Content from T_Bus_ToExamine ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            CallCenterApi.Model.T_Bus_ToExamine model = new CallCenterApi.Model.T_Bus_ToExamine();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 根据工单编号得到一个最新对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_ToExamine GetNewModelByWorkOrderID(string F_WorkOrderId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 * from T_Bus_ToExamine WITH(NOLOCK) ");
            strSql.Append(" where F_WorkOrderId=@F_WorkOrderId and F_IsDelete=0 and F_AssignedId=0 ");
            strSql.Append(" order by F_Id desc");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,50)
            };
            parameters[0].Value = F_WorkOrderId;

            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]); ;
            }
            else
            {
                return null;
            }
        }
        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_ToExamine DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Bus_ToExamine model = new CallCenterApi.Model.T_Bus_ToExamine();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["F_WorkOrderId"] != null)
                {
                    model.F_WorkOrderId = row["F_WorkOrderId"].ToString();
                }
                if (row["F_AssignedId"] != null && row["F_AssignedId"].ToString() != "")
                {
                    model.F_AssignedId = int.Parse(row["F_AssignedId"].ToString());
                }
                if (row["F_CreatUser"] != null)
                {
                    model.F_CreatUser = row["F_CreatUser"].ToString();
                }
                if (row["F_Type"] != null && row["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(row["F_Type"].ToString());
                }
                if (row["F_LimitTime"] != null && row["F_LimitTime"].ToString() != "")
                {
                    model.F_LimitTime = int.Parse(row["F_LimitTime"].ToString());
                }
                
                if (row["F_Result"] != null)
                {
                    model.F_Result = row["F_Result"].ToString();
                }
                if (row["F_IsDelete"] != null && row["F_IsDelete"].ToString() != "")
                {
                    model.F_IsDelete = int.Parse(row["F_IsDelete"].ToString());
                }
                if (row["AuditUser"] != null)
                {
                    model.AuditUser = row["AuditUser"].ToString();
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                { 
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_MainDeptId"] != null)
                {
                    model.F_MainDeptId = row["F_MainDeptId"].ToString();
                }
                if (row["F_Content"] != null)
                {
                    model.F_Content = row["F_Content"].ToString();
                }
                
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,F_WorkOrderId,F_AssignedId,F_LimitTime,F_CreatUser,F_Type,F_Result,F_IsDelete,AuditUser,F_State,F_MainDeptId,F_Content ");
            strSql.Append(" FROM T_Bus_ToExamine ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ID,F_WorkOrderId,F_AssignedId,F_LimitTime,F_CreatUser,F_Type,F_Result,F_IsDelete,AuditUser,F_State,F_MainDeptId,F_Content ");
            strSql.Append(" FROM T_Bus_ToExamine ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Bus_ToExamine ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Bus_ToExamine T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Bus_ToExamine";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return CallCenterApi.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
